// File created 3/17/2015 with four space tab spacing

/** \file
	\brief step timer management
*/

#include "step_timer.h"
#include "simpletools.h"
#include "dda_queue.h"
#include "debug.h"

/// cog variables
static int step_cog = 0;
static int step_stack[60];

/// time until next step
static uint32_t next_step_time;

void step_timer(void *par);

/// initialise timer
void step_timer_init()
{
	next_step_time = 0;

	if(step_cog == 0)
	{
		step_cog = 1 + cogstart(&step_timer, NULL, step_stack, sizeof step_stack);
	}
}

/// stop timer
void step_timer_stop()
{
	if(step_cog > 0)
	{
		cogstop(step_cog - 1);
		step_cog = 0;
	}
}

/// main loop for queueing step
void step_timer(void *par)
{
	while(1)
	{
		waitcnt(next_step_time);
 
		// Check if this is a real step, or just passing time
		if(next_step_time > 0)
		{
			queue_step();
			next_step_time = 0;
		}
	}
}

/// Initialize the next step
void setTimer(uint32_t delay)
{
	if(DEBUG_STEP && (debug_flags & DEBUG_STEP))
	{
		print("Set Timer: %d\n", delay);
	}
	next_step_time = (delay += CNT);
}